// Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
// Autogenerated from Pigeon (v3.2.9), do not edit directly.
// See also: https://pub.dev/packages/pigeon
// ignore_for_file: public_member_api_docs, non_constant_identifier_names, avoid_as, unused_import, unnecessary_parenthesis, prefer_null_aware_operators, omit_local_variable_types, unused_shown_name, unnecessary_import, require_trailing_commas
import 'dart:async';
import 'dart:typed_data' show Uint8List, Int32List, Int64List, Float64List;

import 'package:flutter/foundation.dart' show WriteBuffer, ReadBuffer;
import 'package:flutter/services.dart';

class _NativeApiPluginCodec extends StandardMessageCodec {
  const _NativeApiPluginCodec();
}

abstract class NativeApiPlugin {
  static const MessageCodec<Object?> codec = _NativeApiPluginCodec();

  Future<String?> getLatestAuthToken(String providerName);
  static void setup(NativeApiPlugin? api, {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NativeApiPlugin.getLatestAuthToken', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NativeApiPlugin.getLatestAuthToken was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final String? arg_providerName = (args[0] as String?);
          assert(arg_providerName != null,
              'Argument for dev.flutter.pigeon.NativeApiPlugin.getLatestAuthToken was null, expected non-null String.');
          final String? output =
              await api.getLatestAuthToken(arg_providerName!);
          return output;
        });
      }
    }
  }
}

class _NativeApiBridgeCodec extends StandardMessageCodec {
  const _NativeApiBridgeCodec();
}

class NativeApiBridge {
  /// Constructor for [NativeApiBridge].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  NativeApiBridge({BinaryMessenger? binaryMessenger})
      : _binaryMessenger = binaryMessenger;

  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _NativeApiBridgeCodec();

  Future<void> addPlugin(List<String?> arg_authProvidersList) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.NativeApiBridge.addPlugin', codec,
        binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap = await channel
        .send(<Object?>[arg_authProvidersList]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error =
          (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else {
      return;
    }
  }
}
